#include "StdAfx.h"
#include "AboutDlg.h"
#include "misc.h"

AboutDlg::AboutDlg( UINT idResource )
	: Dialog( idResource )
{
}

AboutDlg::~AboutDlg(void)
{
}

BOOL AboutDlg::VerQueryTranslation( TCHAR *path, TCHAR *subBlock, BYTE **buf, TCHAR **value )
{
	BOOL bRet = FALSE;
	DWORD handle;
	DWORD rlen;
	DWORD *lang;
	UINT vlen;
	TCHAR strStream[100];

	rlen = GetFileVersionInfoSize( path, &handle );

	do {
		*buf = new BYTE[rlen];
		if ( *buf == NULL ) break;

		if ( !GetFileVersionInfo( path, handle, rlen, *buf ) ) break;
		if ( !VerQueryValue( *buf, _T("\\VarFileInfo\\Translation"), (LPVOID*)&lang, &vlen ) ) break;

		_stprintf_s( strStream, 100, _T("\\StringFileInfo\\%04x%04x\\%s"), LOWORD(*lang), HIWORD(*lang), subBlock );
		if ( !VerQueryValue( *buf, strStream, (LPVOID*)value, &vlen ) ) break;

		bRet = TRUE;

	} while ( FALSE );

	return bRet;
}

BOOL AboutDlg::GetFileVersionDW( TCHAR *path, DWORD *value4 )
{
	BYTE *buf = NULL;
	TCHAR *strBuf = NULL;
	BOOL bRet = FALSE;

	do {
		if ( ( path == NULL ) || ( value4 == NULL ) ) break;

		if ( !VerQueryTranslation( path, _T("ProductVersion"), &buf, &strBuf ) ) break;

		if ( ( _stscanf_s( strBuf, _T("%d,%d,%d,%d"), &value4[0], &value4[1], &value4[2], &value4[3] ) != 4 ) &&
			 ( _stscanf_s( strBuf, _T("%d.%d.%d.%d"), &value4[0], &value4[1], &value4[2], &value4[3] ) != 4 ) ) break;

		bRet = TRUE;

	} while ( FALSE );

	if ( buf ) delete[] buf;

	return bRet;
}

BOOL AboutDlg::GetCopyright( TCHAR *path, TCHAR *cp, int len )
{
	BYTE *buf = NULL;
	TCHAR *strBuf = NULL;
	BOOL bRet = FALSE;

	do {
		if ( ( path == NULL ) || ( cp == NULL ) ) break;

		if ( !VerQueryTranslation( path, _T("LegalCopyright"), &buf, &strBuf ) ) break;

		_tcscpy_s( cp, len, strBuf );
		bRet = TRUE;

	} while ( FALSE );

	if ( buf ) delete[] buf;

	return bRet;
}

INT_PTR CALLBACK AboutDlg::DlgProc( UINT uMsg, WPARAM wParam, LPARAM lParam )
{
	int wmId, wmEvent;
	TCHAR		path[_MAX_PATH];
	DWORD		ver[4];
	TCHAR		verstr[100];

	switch( uMsg )
	{
	case WM_INITDIALOG:
		GetModuleFileName( NULL, path, _MAX_PATH );
		if ( GetFileVersionDW( path, ver ) ) {
			_stprintf_s( verstr, 100, _T("%s Ver.%d.%d.%d"), szTitle, ver[0], ver[1], ver[2] );
			SetItemText( IDC_VERSTRING , verstr );
		}
		if ( GetCopyright( path, verstr, 100 ) ) {
			SetItemText( IDC_COPYRIGHT, verstr );
		}
		return (INT_PTR)TRUE;

	case WM_COMMAND:
		wmId	= LOWORD(wParam);
		wmEvent = HIWORD(wParam);
		switch( wmId )
		{
		case IDOK:
		case IDCANCEL:
			EndDialog( m_hDlg, wmId );
			break;
		}
		break;
	}
	return (INT_PTR)FALSE;
}
