#include "StdAfx.h"
#include "Dialog.h"
#include "misc.h"
#include <windowsx.h>

#define PROPERTY_STRING _T("DialogClassInstance")

Dialog::Dialog(	UINT idResource )
	: m_hDlg( NULL )
	, m_idResource( idResource )
{
}

Dialog::~Dialog(void)
{
}

HWND Dialog::SetFocus(void)
{
	return m_hDlg ? ::SetFocus( m_hDlg ) : NULL;
}

INT_PTR CALLBACK Dialog::_RootDlgProc( HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL bWnd )
{
	Dialog *dlg = NULL;
	INT_PTR iRet = 0;

	switch( uMsg )
	{
	case WM_INITDIALOG:
		dlg = (Dialog*)lParam;
		if ( dlg ) {
			SetProp( hDlg, PROPERTY_STRING, (HANDLE)dlg );
			dlg->m_hDlg = hDlg;
		}
		break;
	}

	dlg = (Dialog*)GetProp( hDlg, PROPERTY_STRING );
	if ( dlg ) {
		iRet = dlg->DlgProc( uMsg, wParam, lParam );
	}
	// [hX̏ꍇAftHgĂ
	else if ( bWnd ) {
		iRet = DefWindowProc( hDlg, uMsg, wParam, lParam );
	}

	// switchŌĂԂƃIuWFNgɔׂȂȂ̂ōŌ
	if ( uMsg == WM_DESTROY ) {
		RemoveProp( hDlg, PROPERTY_STRING );
	}

	return iRet;
}

INT_PTR CALLBACK Dialog::_RootWndProc( HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
	return _RootDlgProc( hDlg, uMsg, wParam, lParam, TRUE );
}

INT_PTR Dialog::DoModal(HWND hParent)
{
	return DialogBoxParam( hInst, MAKEINTRESOURCE(m_idResource), hParent, (DLGPROC)_RootDlgProc, (LPARAM)this );
}

BOOL Dialog::DoModeless(HWND hParent, int nCmdShow)
{
	HWND hDlg;
	BOOL bRet = FALSE;

	hDlg = CreateDialogParam( hInst, MAKEINTRESOURCE(m_idResource), hParent, (DLGPROC)_RootWndProc, (LPARAM)this );
	if ( hDlg ) {
		ShowWindow( hDlg, nCmdShow );
		UpdateWindow( hDlg );
		bRet = TRUE;
	}

	return bRet;
}

INT_PTR Dialog::RunMsgLoop(void)
{
	MSG msg;

	while (GetMessage(&msg, NULL, 0, 0))
	{
		if (!IsDialogMessage(m_hDlg, &msg))
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return (INT_PTR)msg.wParam;
}

BOOL Dialog::GetDlgItemRect( int nIDDlgItem, RECT* rct )
{
	BOOL bRet = FALSE;
	POINT pt;
	HWND hWnd = GetDlgItem( m_hDlg, nIDDlgItem );
	if (hWnd != NULL)
	{
		bRet = GetWindowRect( hWnd, rct );
		{
			pt.x = rct->left;
			pt.y = rct->top;
			bRet = ScreenToClient( m_hDlg, &pt );
			rct->left = pt.x;
			rct->top = pt.y;

			pt.x = rct->right;
			pt.y = rct->bottom;
			bRet = ScreenToClient( m_hDlg, &pt );
			rct->right = pt.x;
			rct->bottom = pt.y;
		}
	}
	return bRet;
}

void Dialog::AdjustComboBoxHeight( UINT nIDDlgItem, UINT num )
{
	COMBOBOXINFO cbinfo;
	RECT cbrect;
	int dropHeight;

	HWND hWndCb = GetDlgItem( m_hDlg, nIDDlgItem );

	memset( &cbinfo, 0, sizeof( cbinfo ) );
	cbinfo.cbSize = sizeof( cbinfo );
	GetComboBoxInfo( hWndCb, &cbinfo );

	GetWindowRect( cbinfo.hwndList, &cbrect );

	dropHeight = ComboBox_GetItemHeight( hWndCb );
	MoveWindow( cbinfo.hwndList,
				cbrect.left,
				cbrect.top,
				cbrect.right - cbrect.left,
				dropHeight * num + 2,
				TRUE);

}
