#ifndef _DROPTARGET_H_
#define _DROPTARGET_H_

#include <windows.h>
#include <ole2.h>

class CDropTarget : public IDropTarget
{
public:
	STDMETHODIMP QueryInterface(REFIID riid, void **ppvObject);
	STDMETHODIMP_(ULONG) AddRef();
	STDMETHODIMP_(ULONG) Release();

	STDMETHODIMP DragEnter(IDataObject *pDataObj, DWORD grfKeyState, POINTL pt, DWORD *pdwEffect);
	STDMETHODIMP DragOver(DWORD grfKeyState, POINTL pt, DWORD *pdwEffect);
	STDMETHODIMP DragLeave();
	STDMETHODIMP Drop(IDataObject *pDataObj, DWORD grfKeyState, POINTL pt, DWORD *pdwEffect);

	typedef BOOL (*ISVALIDFILECALLBACK)( TCHAR *filename );

	CDropTarget(HWND hwnd, ISVALIDFILECALLBACK callback = NULL);
	~CDropTarget(void);

protected:
	LONG m_cRef;
	HWND m_hWnd;
	BOOL m_bSupportFormat;
	ISVALIDFILECALLBACK IsValidCallback;

	typedef struct _DROPDATA {
		HENHMETAFILE hEnhMetaFile;
		POINT        pt;
	} DROPDATA;
};

#endif//_DROPTARGET_H_
