#ifndef _MAIN_DIALOG_H_
#define _MAIN_DIALOG_H_

#include "ReposDialog.h"
#include <atlbase.h>
#include <Shobjidl.h>
#include <commctrl.h>
#include "DropTarget.h"
#include "DemuxThread.h"
#include <shellapi.h>
#include <windowsx.h>
#include "AboutDlg.h"

class MainDialog : public ReposDialog
{
public:
	MainDialog(UINT idResource);
	~MainDialog(void);

	virtual BOOL DoModeless(HWND hParent = NULL, int nCmdShow = SW_SHOW);
	int InitControls(void);
	static BOOL IsValidExt( TCHAR *szPath );

protected:
	typedef enum _PROG_STATE {
		STATE_NONE,
		STATE_FINISHED,
		STATE_FAILED,
	} PROG_STATE;

	HIMAGELIST imageList;
	IDropTarget *pDropTarget;
	CComPtr<ITaskbarList3> m_ptrTaskbarList3;
	HWND hList;
	int nCurItem;
	DemuxThread *m_pDemux;
	BOOL bInDemux;
	AboutDlg *m_aboutDlg;

	BOOL Cls_OnInitDialog(HWND hwnd, HWND hwndFocus, LPARAM lParam);
	void Cls_OnDropFiles(HWND hwnd, HDROP hdrop);
	void Cls_OnSysCommand(HWND hwnd, UINT cmd, int x, int y);
	void Cls_OnCommand(HWND hwnd, int id, HWND hwndCtl, UINT codeNotify);
	void Cls_OnDestroy(HWND hwnd);

	BOOL Cls_OnNotify( WPARAM wParam, LPARAM lParam );
	void Cls_OnDemuxProgress( int progress );
	void Cls_OnDemuxSplit( int errorCount );

	INT_PTR CALLBACK DlgProc( UINT uMsg, WPARAM wParam, LPARAM lParam );
	BOOL InitInstance( HWND hParent = NULL );
	void InsertSystemMenu(void);
	int GetImageIndex( PROG_STATE state );
	int ListInsertItem( TCHAR *path );
	INT_PTR ListCustom( LPNMLVCUSTOMDRAW lplvcd );
	BOOL GetCellRect(int iRow, int iCol, int nArea, RECT *rect);
	void UpdateControls(void);
	BOOL Demux( void );
	BOOL Next( PROG_STATE curState );
	int GetPending(void);
	void CalcMinSize(void);
	void MainSetMin( POINT *pt );
	BOOL FillSolidRect( HDC hdc, RECT *rect, COLORREF color );
};

#endif//_MAIN_DIALOG_H_
