#include "StdAfx.h"
#include "ReposDialog.h"

ReposDialog::ReposDialog(UINT idResource)
	: Dialog( idResource )
	, reposItems( NULL )
	, reposNum( 0 )
{
}

ReposDialog::~ReposDialog(void)
{
}

void ReposDialog::ReposInit(void)
{
	GetClientRect( m_hDlg, &prevWinRect );

	for ( int c = 0; c < reposNum; c++ ) {
		GetDlgItemRect( reposItems[c].id, &reposItems[c].inipos );
	}
}

void ReposDialog::ReposResize( int cx, int cy )
{
	int left, top, width, height;
	int prevWinWidth, prevWinHeight;

	if ( m_hDlg == NULL ) return;

	prevWinWidth = prevWinRect.right - prevWinRect.left;
	prevWinHeight = prevWinRect.bottom - prevWinRect.top;

	for ( int c = 0; c < reposNum; c++ ) {
		left = reposItems[c].inipos.left;
		top = reposItems[c].inipos.top;
		width = reposItems[c].inipos.right - left;
		height = reposItems[c].inipos.bottom - top;

		left +=   ( ( reposItems[c].flag & ANCHOR_MASK_HORIZON )  == ANCHOR_RIGHT )         ? ( cx - prevWinWidth )  : 0;
		width +=  ( ( reposItems[c].flag & ANCHOR_MASK_HORIZON )  == ANCHOR_MASK_HORIZON )  ? ( cx - prevWinWidth )  : 0;
		top +=    ( ( reposItems[c].flag & ANCHOR_MASK_VERTICAL ) == ANCHOR_BOTTOM )        ? ( cy - prevWinHeight ) : 0;
		height += ( ( reposItems[c].flag & ANCHOR_MASK_VERTICAL ) == ANCHOR_MASK_VERTICAL ) ? ( cy - prevWinHeight ) : 0;

		MoveWindow( GetDlgItem( m_hDlg, reposItems[c].id ), left, top, width, height, FALSE );
	}
	InvalidateRect( m_hDlg, NULL, TRUE );
}

void ReposDialog::ReposSetMin( POINT *pt )
{
	*pt = ptMinSize;
}

void ReposDialog::ReposProc( UINT uMsg, WPARAM wParam, LPARAM lParam )
{
	MINMAXINFO *lpMMI;

	switch( uMsg )
	{
	case WM_INITDIALOG:
		ReposInit();
		break;

	case WM_GETMINMAXINFO:
		lpMMI = (MINMAXINFO*)lParam;
		ReposSetMin( &lpMMI->ptMinTrackSize );
		break;

	case WM_SIZE:
		ReposResize( LOWORD(lParam), HIWORD(lParam) );
		break;
	}
}
